package com.persagy.controller;


import com.alibaba.fastjson.JSONObject;
import com.persagy.cache.AlarmInfoCache;
import com.persagy.client.GroupNettyClient;
import com.persagy.entity.NettyMessage;
import com.persagy.entity.ZktAlarmRecordDO;
import com.persagy.repository.AlarmRecordRepository;
import com.persagy.service.AlarmHandleService;
import com.persagy.utils.LockUtil;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.transaction.Transactional;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;

@Api(tags = "hello")
@RestController
@RequestMapping("hello")
@Slf4j
public class HelloWorld {
	@Autowired
	AlarmHandleService alarmHandleService;

	@Autowired
	private GroupNettyClient groupNettyClient;
	@Autowired
	AlarmInfoCache alarmInfoCache;
	@Autowired
	AlarmRecordRepository alarmRecordRepository;
	@PostMapping("/")
	public String world(@RequestBody JSONObject jsonObject) throws Exception {
		return "hello world!";
	}
	@PostMapping("/testMesage")
	public String testMesage(@RequestBody JSONObject jsonObject) throws Exception {
		NettyMessage nettyMessage = new NettyMessage(groupNettyClient.projectId);
		nettyMessage.setRemark("连接已经建立；");
		nettyMessage.setOpCode(4);
		JSONObject content = new JSONObject();
		content.put("groupCode", groupNettyClient.groupCode);
		content.put("projectId", groupNettyClient.projectId);
		nettyMessage.setContent(Arrays.asList(content));
		groupNettyClient.sendMessage(nettyMessage.toString());
		return "成功";
	}

	@PostMapping("/test")
	public String test(@RequestBody JSONObject jsonObject) throws Exception {
		LockUtil.getInstance().lock.lock();
		try {
			LockUtil.getInstance().setExecute(!LockUtil.getInstance().isExecute());
			//加个等待，保证正在执行的逻辑执行成功
			Thread.sleep(2000);
			if(LockUtil.getInstance().isExecute()){
				LockUtil.getInstance().condition.signalAll();
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		} finally {
			LockUtil.getInstance().lock.unlock();
		}
		AtomicInteger atomicInteger = new AtomicInteger(0);
		alarmInfoCache.getAlarmDefineMap().entrySet().forEach(entry->{
//			log.info("[{}]的key:[{}],value:[{}]",atomicInteger.getAndIncrement(),entry.getKey(),entry.getValue());
		});
		return "成功";
	}

	@PostMapping("/test2")
	public String test2(@RequestBody JSONObject jsonObject) throws Exception {
		String message = jsonObject.getString("message");
		alarmHandleService.handleIotMsg(message);
		return "成功";
	}

	@PostMapping("/test3")
	public ArrayList<ZktAlarmRecordDO> test3(@RequestBody JSONObject jsonObject) throws Exception {
		String defineId = jsonObject.getString("itemCode") + "-" + jsonObject.getString("objId");
		ZktAlarmRecordDO zktAlarmRecordDO = alarmRecordRepository.findById(defineId).orElse(new ZktAlarmRecordDO());
		zktAlarmRecordDO.setDefinitionId(defineId);
		zktAlarmRecordDO.setItemCode(jsonObject.getString("itemCode"));
		zktAlarmRecordDO.setObjId(jsonObject.getString("objId"));
		zktAlarmRecordDO.setAlarmId(jsonObject.getString("id"));
		ZktAlarmRecordDO save = alarmRecordRepository.save(zktAlarmRecordDO);
		log.info("保存结果为：{}",save);
		Iterable<ZktAlarmRecordDO> all = alarmRecordRepository.findAll();
		Iterator<ZktAlarmRecordDO> iterator = all.iterator();
		ArrayList<ZktAlarmRecordDO> list = new ArrayList<>();
		while (iterator.hasNext()) {
			list.add(iterator.next());
		}
		return list;
	}

	@PostMapping("/test4")
	public void test4() throws Exception {
		String defineId = "2004-VOEi56c25a67412a417fbf225ca1722f3a27";
		Thread thread1 = new Thread() {
			@Override
			public void run() {
				try {
					log.info("{}开始，参数为: {}, {}", Thread.currentThread().getName(), null, "1");
					alarmRecordFindAndUpdate(defineId, null, "1");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		};
		thread1.start();

		Thread thread2 = new Thread() {
			@Override
			public void run() {
				try {
					log.info("{}开始，参数为: {}, {}", Thread.currentThread().getName(), "xxx", "2");
					alarmRecordFindAndUpdate(defineId, "xxx", "2");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		};
		thread2.start();
	}

	@Transactional
	public void alarmRecordFindAndUpdate(String defineId, String alarmId, String state) throws Exception {
		Optional<ZktAlarmRecordDO> zktAlarmRecordDO = alarmRecordRepository.findById(defineId);
		log.info("{}完成查询", Thread.currentThread().getName());
		Thread.sleep(3000);
		if (zktAlarmRecordDO.isPresent()) {
			ZktAlarmRecordDO alarmRecordDO = zktAlarmRecordDO.get();
			alarmRecordDO.setAlarmId(alarmId);
			alarmRecordDO.setState(state);
			alarmRecordRepository.save(alarmRecordDO);
		}
		log.info("{}完成更新", Thread.currentThread().getName());
	}


}

